#include <oxstd.h>
#import <maximize>

decl duur1, censor1, duur2, censor2, X, d, c, obs, instroom, t_mat;

loglikelihood(const param)
{
	decl theta1, theta2, delta1, d1, d2, hulp1, hulp2, i, j, xb1, xb2, p, v1, v2, v, lik, ll, t,
	     instroom1, instroom2, uitstroom1, uitstroom2;

	// Duration dependence and calendar-time effects (exit rate and sanction rate)

	theta1 = exp((0|param[0:2]|(param[2])|param[3:6])~
		      (param[14]+(0|param[0:2]|(param[2])|param[3:6]))~
		      (param[15]+(0|param[0:2]|(param[2])|param[3:6]))~
		      (param[16]+(0|param[0:2]|(param[2])|param[3:6]))~
	             (param[17]+(0|param[0:2]|(param[42]+param[2])|(param[43]+param[3:6])))~
	             (param[18]+(0|param[0:2]|(param[42]+param[2])|(param[43]+param[3:6])))~
	             (param[19]+(0|param[0:2]|(param[42]+param[2])|(param[43]+param[3:6])))~
	             (param[20]+(0|param[0:2]|(param[42]+param[2])|(param[43]+param[3:6])))~
	             (param[21]+(0|param[0:2]|(param[44]+param[2])|(param[45]+param[3:6])))~
	             (param[22]+(0|param[0:2]|(param[44]+param[2])|(param[45]+param[3:6])))~
	             (param[23]+(0|param[0:2]|(param[44]+param[2])|(param[45]+param[3:6])))~
	             (param[24]+(0|param[0:2]|(param[44]+param[2])|(param[45]+param[3:6])))~
	             (param[25]+(0|param[0:2]|param[2:6]))~
	             (param[26]+(0|param[0:2]|param[2:6]))~
	             (param[27]+(0|param[0:2]|param[2:6])));

 	theta2=exp((0|param[7:9]|param[9:13])~
	             (param[28]+(0|param[7:9]|param[9:13]))~
	             (param[29]+(0|param[7:9]|param[9:13]))~
	             (param[30]+(0|param[7:9]|param[9:13]))~
	             (param[31]+(0|param[7:9]|param[9:13]))~
	             (param[32]+(0|param[7:9]|param[9:13]))~
	             (param[33]+(0|param[7:9]|param[9:13]))~
	             (param[34]+(0|param[7:9]|param[9:13]))~
	             (param[35]+(0|param[7:9]|param[9:13]))~
	             (param[36]+(0|param[7:9]|param[9:13]))~
	             (param[37]+(0|param[7:9]|param[9:13]))~
	             (param[38]+(0|param[7:9]|param[9:13]))~
	             (param[39]+(0|param[7:9]|param[9:13]))~
	             (param[40]+(0|param[7:9]|param[9:13]))~
	             (param[41]+(0|param[7:9]|param[9:13])));
				 

	// Sanction effect
	delta1 = exp(param[46]); 
	
    d1 = duur1;  // duration to exit
    d2 = duur2;	 // duration to sanction

	// Integrated hazards 
    hulp1 = zeros(obs,2);
    hulp2 = zeros(obs,2);

	instroom1 = instroom;
	instroom2 = instroom;
	uitstroom1 = instroom1;
	uitstroom2 = instroom2;
	
	for(i=0;i<rows(d);++i)
	{

		uitstroom1 = uitstroom1 + (d1 .> 0) .* (d[i] * (d1 .> d[i]) + d1 .* (d1 .<= d[i]));
		uitstroom2 = uitstroom2 + (d2 .> 0) .* (d[i] * (d2 .> d[i]) + d2 .* (d2 .<= d[i]));

		for(j=1;j<rows(c);++j)
		{
			hulp1[][1]= hulp1[][1] + theta1[i][j-1] * (d1 .> 0) .* (d1 .<= d[i]) .* (uitstroom1 .> c[j-1]) .* (uitstroom1 .<= c[j]) .*
														((d2 .>= d1)
														 + delta1 .* (d2 .< d1));

			hulp1[][0]= hulp1[][0] + theta1[i][j-1] * (
					(uitstroom2 .>= uitstroom1) .* ( 
														 (uitstroom1-instroom1) .* (instroom1 .> c[j-1]) .* (uitstroom1 .<= c[j])
														 + (uitstroom1-c[j-1]) .* (instroom1 .<= c[j-1]) .* (uitstroom1 .> c[j-1]) .* (uitstroom1 .<= c[j])
														 + (c[j]-instroom1) .* (instroom1 .> c[j-1]) .* (instroom1 .<= c[j]) .* (uitstroom1 .> c[j])
														 + (c[j]-c[j-1]) * (instroom1 .<= c[j-1]) .* (uitstroom1 .> c[j])
														 )														 
				  + (uitstroom2 .< uitstroom1)  .* (
														 ((uitstroom2-instroom1) + delta1 * (uitstroom1-uitstroom2)) .*
														 (instroom1 .> c[j-1]) .* (uitstroom2 .> instroom1) .* (uitstroom1 .<= c[j])
														 + delta1 * (uitstroom1-instroom1) .*
														 (instroom1 .> c[j-1]) .* (uitstroom2 .<= instroom1) .* (uitstroom1 .<= c[j])
														 + ((uitstroom2-instroom1) + delta1 * (c[j]-uitstroom2))	.*
														 (instroom1 .> c[j-1]) .* (uitstroom2 .> instroom1) .* (uitstroom2 .<= c[j]) .* (uitstroom1 .> c[j])
														 + delta1 * (c[j]-instroom1) .*
														 (instroom1 .> c[j-1]) .* (instroom1 .<= c[j]) .* (uitstroom2 .<= instroom1) .* (uitstroom1 .> c[j])
														 + (c[j]-instroom1) .*
														 (instroom1 .> c[j-1]) .* (instroom1 .<= c[j]) .* (uitstroom2 .> c[j])
														 + ((uitstroom2-c[j-1]) + delta1*(uitstroom1-uitstroom2)) .*
														 (instroom1 .<= c[j-1]) .* (uitstroom2 .> c[j-1]) .* (uitstroom1 .<= c[j])
														 + ((uitstroom2-c[j-1]) + delta1*(c[j]-uitstroom2)) .*
														 (instroom1 .<= c[j-1]) .* (uitstroom2 .> c[j-1]) .* (uitstroom2 .<= c[j]) .* (uitstroom1 .> c[j])
														 + (c[j]-c[j-1]) *
														 (instroom1 .<= c[j-1]) .* (uitstroom2 .> c[j])
														 + delta1 * (uitstroom1-c[j-1]) .*
														 (instroom1 .<= c[j-1]) .* (uitstroom2 .<= c[j-1]) .* (uitstroom1 .> c[j-1]) .* (uitstroom1 .<= c[j])
														 + delta1 * (c[j]-c[j-1]) *
														 (instroom1 .<= c[j-1]) .* (uitstroom2 .<= c[j-1]) .* (uitstroom1 .> c[j])
														 ));
		
			hulp2[][0]= hulp2[][0] + theta2[i][j-1] * (
														(uitstroom2-instroom2) .* (instroom2 .> c[j-1]) .* (uitstroom2 .<= c[j])
														 + (uitstroom2-c[j-1]) .* (instroom2 .<= c[j-1]) .* (uitstroom2 .> c[j-1]) .* (uitstroom2 .<= c[j])
														 + (c[j]-instroom2) .* (instroom2 .> c[j-1]) .* (instroom2 .< c[j]) .* (uitstroom2 .> c[j])
														 + (c[j]-c[j-1]) * (instroom2 .<= c[j-1]) .* (uitstroom2 .> c[j])
														 );

			hulp2[][1]= hulp2[][1] + theta2[i][j-1] * (d2 .> 0) .* (d2 .<= d[i]) .* (uitstroom2 .> c[j-1]) .* (uitstroom2 .<= c[j]);

		}
		
		instroom1 = instroom1 + (d1 .> 0) .* (d[i] * (d1 .> d[i]) + d1 .* (d1 .<= d[i]));
		instroom2 = instroom2 + (d2 .> 0) .* (d[i] * (d2 .> d[i]) + d2 .* (d2 .<= d[i]));
	
	     d1 = d1 - d[i];
    	 d2 = d2 - d[i];
	}


	// Observed heterogenity

	xb1 = exp(X*param[47:54]);
	xb2 = exp(X*param[55:62]);

   	// Unobserved heterogenity
	// Mass points
	v1 = exp(param[63:64]);
    v2 = exp(param[65:66]);
	v = (v1**ones(2,1))~(ones(2,1)**v2);
	
	// Probability mass associated to points
	p = 0|(1|exp(param[67]))/(sumc(exp(param[67]))+1)|0;

	// Likelihood function
   	lik = zeros(rows(t_mat),4);

	for(i=1;i<3;++i)
	{
		ll = (v[i][0] * xb1 .* hulp1[][1]).^(censor1) .* exp(-v[i][0] * xb1 .* hulp1[][0]) .*
				   (v[i][1] * xb2 .* hulp2[][1]).^(censor2) .* exp(-v[i][1] * xb2 .* hulp2[][0]);
		lik[][i] = ll[t_mat[][0]];
		for(t=1;t<=3;++t)
		{
			lik[][i] = lik[][i] .* ((t_mat[][t] .== 0) + (t_mat[][t] .> 0) .* ll[t_mat[][t]]);

		}
	}

	return log(lik*p);
}


likelihood(const param, const loglik, const score, const hessian)
{
	decl logl;

	logl = loglikelihood(param);
//	savemat("param3.xls",param);
	loglik[0] = meanc(logl);

	return 1;
}


afgeleide(const param)
{
	decl logl, score, i, p, z1, z2, d0, k, k0, hulp;

	d0 = zeros(param);
	z1 = zeros(obs,rows(param));
	z2 = zeros(obs,rows(param));

	k = 0;
	while (k < rows(param))
	{
		k0 = k;
		for(i=1;i<numprocs;++i)
		{
			if(k < rows(param))
			{
				d0[k] = max(fabs(0.0005*param[k])|0.0005);
				p = param;
				p[k] = p[k] + d0[k];
				OxMPI_Send(&indicator,i,myid);
				OxMPI_Send(&p,i,myid);
			}
			k = k + 1;
		}
		k = k0;
		for(i=1;i<numprocs;++i)
		{
			if(k < rows(param))
			{
				hulp = OxMPI_Recv(i,OxMPI_ANY_TAG);
				z1[][k] = hulp[0];
			}
			k = k + 1;
		}
	}

	k = 0;
	while (k < rows(param))
	{
		k0 = k;
		for(i=1;i<numprocs;++i)
		{
			if(k < rows(param))
			{
				p = param;
				p[k] = p[k] - d0[k];
				OxMPI_Send(&indicator,i,myid);
				OxMPI_Send(&p,i,myid);
			}
			k = k + 1;
		}
		k = k0;
		for(i=1;i<numprocs;++i)
		{
			if(k < rows(param))
			{
				hulp = OxMPI_Recv(i,OxMPI_ANY_TAG);
				z2[][k] = hulp[0];
			}
			k = k + 1;
		}
	}

	score = zeros(obs,rows(param));

	for(k=0;k<rows(param);++k)
	{
		score[][k] = (z1[][k]-z2[][k])./(2*d0[k]);
	}
	
	return score;
}


main()
{
	decl data, wwrecht, param, function, score, sdev, cov, geslacht, leeftijd, kinderen, nationaliteit, leefvorm, redeninstroom, thuiswonend, f, p, i, x, t;

	// Construct data
	
	data = loadmat("dataCarrotStick.xls");
	data = sortbyc(data,0);
	data = selectifr(data,(data[][1] .< data[][3])); 		// remove welfare spells of 0 days
	data = selectifr(data,(data[][5] .<100));				// remove individuals with a too high age
	data = selectifr(data,(data[][6] .== 0));				// select men or use 1 for selecting women only 

	obs = rows(data);
 
	t_mat = zeros(1,21);
	t_mat[0][0] = 0;
	t_mat[0][20] = data[0][0];
	i = 0;
	x = 1;
	for(t=1; t<=obs-1; ++t)
	{
		
		if(data[t][0] == t_mat[i][20])
		{	
			t_mat[i][x] = t;
			x = x + 1;
		}
		else
		{
			t_mat = t_mat|zeros(1,21);
			i = i + 1;
			t_mat[i][0] = t;
			t_mat[i][20] = data[t][0];
			x = 1;
			
		}
	}
	t_mat = t_mat[][0:3];

	instroom = data[][1]+1;
	duur1 = data[][3]-data[][1];
	censor1 = (data[][4] .== 11);
	duur2 = data[][11]-data[][1];
	duur2 = duur2 .* (duur2 .> 0);
	censor2 = (duur2 .> 0);
	duur2 = duur2 .* (censor2 .== 1) + duur1 .* (censor2 .== 0);

	geslacht = data[][6];
	leeftijd = log(100 - data[][5]);
	kinderen = (data[][7] .> 0);
	leefvorm = (data[][9] .== 1);
	nationaliteit = (data[][8] .> 1);
	redeninstroom = (data[][2] .== 1)~(data[][2] .== 11)~(data[][2] .== 14);
	thuiswonend = (data[][10] .== 3);
	
	X = leeftijd~kinderen~leefvorm~nationaliteit~redeninstroom~thuiswonend;

	d=91|91|91|61|31|183|182|365|1000;

	c=0|90|181|273|365|455|546|638|730|820|911|1003|1095|1185|1271|1363;
	
	param =  <
      0.30637 ;     0.25162 ;     0.13495  ;   0.061594 ;    0.046730 ;    -0.29526;
     -0.38822 ;    -0.19772 ;    -0.16300  ;   -0.17232 ;   -0.074313 ;    0.023342;
     -0.10596 ;    -0.29844 ;     0.16218  ;   0.046174 ;    -0.13843 ;   0.0043708;
      0.11964 ;    0.060198 ;   0.0026905  ;  -0.029575 ;    -0.15199 ;    0.043928;
     -0.18489 ;    -0.21875 ;    -0.36547  ;   -0.83645 ;     0.82618 ;     0.61466;
      0.44933 ;     0.92833 ;     0.75954  ;    0.77281 ;     0.50496 ;     0.74573;
      0.78691 ;     0.91867 ;     0.93568  ;    0.95487 ;     0.78067 ;      1.2013;
      0.10695 ;   -0.093373 ;     0.10321  ;   0.019685 ;     0.15729 ;     0.87051;
     -0.31024 ;   0.0025630 ;    -0.22028  ;    0.13374 ;     0.13736 ;   -0.070996;
      0.26739 ;      1.6591 ;    -0.32383  ;  -0.072055 ;    -0.24725 ;   -0.087586;
      0.48456 ;    0.068450 ;     0.20667  ;    -10 ;    -11 ;     -15;   -16; 0>;
	
	MaxControl(-1,1);
//		MaxControlEps(1e-3,1e-3);
	MaxBFGS(likelihood, &param, &function, 0, FALSE);

	score = afgeleide(param);
	cov = invert(score'score);
	sdev = sqrt(diagonal(cov));
	println(param~sdev');

	p = 1/(1+exp(param[67]));
	println("probabilities ", p~(1-p));
	println("sdev ", sdev[67]*p*(1-p));

}